<?php

/*****************************************************************
 *** ERROR HANDLER
 *** SEE http://www.zend.com/zend/spotlight/error.php
 *** AND http://php.weblogs.com/php_error_handler_mail 
 ****************************************************************/

function ErrorHandler($errno,$errstr,$errfile,$errline){
    $error_msg = " $errstr occured in $errfile on $errline at ".date("D M j G:i:s T Y"); // le message gnr
    $email_addr = "webmaster@supersite.net"; //le mail  envoyer
    $remote_dbg = "localhost"; 
    $email = true; // envoyer un mail ?
    $stdlog = false; 
    $remote = false; 
    $display = false; // montrer l'erreur  l'utilisateur ?
    $header = false; // possible, if you use output buffering
    $notify = true; // activer ou pas la notification
    $halt_script = true; 

    if (($errno & error_reporting()) == 0) /* ignore error */
        return;

    switch($errno) { 
    case E_USER_NOTICE: 
    case E_NOTICE: 
        $halt_script = false;
        $email=false;
        $type = "Notice"; 
        break; 

    case E_USER_WARNING: 
    case E_COMPILE_WARNING: 
    case E_CORE_WARNING: 
    case E_WARNING: 
        $halt_script = false;
        $type = "Warning"; 
        break; 

    case E_USER_ERROR: 
    case E_COMPILE_ERROR: 
    case E_CORE_ERROR: 
    case E_ERROR: 
        $type = "Fatal Error";
        $header = false;
        break; 

    case E_PARSE: 
        $type = "Parse Error"; 
        break; 

    default: 
        $type = "Unknown Error"; 
        break; 
    }

    if($notify) { 
        $error_msg = $type . $error_msg; 
        if($email){
            /* headers */
            $headers  = "MIME-Version: 1.0\r\n";
            $headers .= "Content-type: text/html; charset=iso-8859-1\r\n";
            $headers .= "From: AutoMail ".$_SERVER['HTTP_HOST']." <$email_addr>\r\n";
            /* qui chie */
            $where = 'http://'.$_SERVER['HTTP_HOST'].$_SERVER['SCRIPT_NAME'].'?rien=1';
            reset($_GET);
            while(list($name, $value) = each($_GET)){
                    $where=$where."&$name=$value";
            } // while
            $where = 'constat l : <br><a href="'.$where.'" >'.$where.'</a>';
            /* pourquoi dont ? */
            ob_start();
            phpinfo(INFO_VARIABLES);                
            $infos = ob_get_contents();
            ob_end_clean();
            $why = $infos;
            /* mail */
            $error_mail = '<HTML><BODY> NOTIFICATION D\'ERREUR : <br><br><hr>'.$error_msg.'<hr>'.$where.'<hr><br><br>'.$why.'</BODY></HTML>';
            error_log($error_mail, 1, $email_addr, $headers); 
        }
        if($remote) error_log($error_msg, 2, $remote_dbg); 
        if($display) echo $error_msg; 
        if($stdlog) { 
            if($log_file == "") {
                error_log($error_msg, 0); 
            } 
            else {
                error_log($error_msg."\n", 3, $log_file); 
            }
        }
        if ($header) {
            header('Location: $MAKLER_URL/error/error.php');
        }
    } 
    if($halt_script) exit -1; 
}
set_error_handler('ErrorHandler');


?>
